<template>
    <div>
        <form @submit.prevent="onSubmit">
            <div class="col-md-12">
                <h2><i class="fa fa-list-alt"></i> Dados gerais</h2>
            </div>


            <div class="col-md-12">
                <div class="form-group col-md-3" :class="{'has-error' : errors_provider.tipo}">
                    <label>Tipo<b class="text-danger">*</b></label>
                    <select name="tipo" class="form-control" v-model="formData.tipo"
                            :disabled="isUpdate">
                        <option value="">--Selecione--</option>
                        <option value="fisica">Pessoa Física</option>
                        <option value="juridica">Pessoa Jurídica</option>
                        <option value="estrangeiro">Estrangeiro</option>
                    </select>
                    <label class="error" v-if="errors_provider.tipo">{{errors_provider.tipo[0]}}</label>
                </div>

                <div class="form-group col-md-5" :class="{'has-error' : errors_provider.name}">
                    <label>Nome
                        <span v-if="formData.tipo== 'juridica'">Fantasia</span>
                        <b class="text-danger">*</b></label>
                    <input type="text" class="form-control" v-model="formData.name">
                    <label class="error" v-if="errors_provider.name">{{errors_provider.name[0]}}</label>
                </div>

                <div class="form-group col-md-4" :class="{'has-error' : errors_provider.email}">
                    <label>Email</label>
                    <input type="email" class="form-control" v-model="formData.email">
                    <label class="error" v-if="errors_provider.email">{{errors_provider.email[0]}}</label>
                </div>
            </div>

            <!-- Pessoa física  -->
            <div v-if="formData.tipo== 'fisica'">

                <div class="col-md-12">
                    <div class="form-group col-md-4" :class="{'has-error' : errors_type_provider_physical.cpf}">
                        <label>CPF</label>
                        <input-mask type="text" class="form-control" mask="111.111.111-11"
                                    v-model="formData.type_provider_physical.cpf"/>
                        <label class="error" v-if="errors_type_provider_physical.cpf">
                            {{errors_type_provider_physical.cpf[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-4" :class="{'has-error' : errors_type_provider_physical.rg}">
                        <label>RG</label>
                        <input type="text" class="form-control"
                               v-model="formData.type_provider_physical.rg">
                        <label class="error" v-if="errors_type_provider_physical.rg">
                            {{errors_type_provider_physical.rg[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-4"
                         :class="{'has-error' : errors_type_provider_physical.data_nascimento}">
                        <label>Data de nascimento</label>
                        <input-date v-model="formData.type_provider_physical.data_nascimento"
                                    :config="config" class="form-control form-date"></input-date>
                        <label class="error" v-if="errors_type_provider_physical.data_nascimento">
                            {{errors_type_provider_physical.data_nascimento[0]}}
                        </label>
                    </div>
                </div>
            </div>

            <!-- Pessoa jurídica  -->
            <div v-if="formData.tipo== 'juridica'">

                <div class="col-md-12">
                    <div class="form-group col-md-4" :class="{'has-error' : errors_type_provider_legal.cnpj}">
                        <label>CNPJ</label>
                        <input-mask type="text" class="form-control" mask="11.111.111/1111-11"
                                    v-model="formData.type_provider_legal.cnpj"/>
                        <label class="error" v-if="errors_type_provider_legal.cnpj">
                            {{errors_type_provider_legal.cnpj[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-4" :class="{'has-error' : errors_type_provider_legal.razao_social}">
                        <label>Razão social</label>
                        <input type="text" class="form-control"
                               v-model="formData.type_provider_legal.razao_social">
                        <label class="error" v-if="errors_type_provider_legal.razao_social">
                            {{errors_type_provider_legal.razao_social[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-4"
                         :class="{'has-error' : errors_type_provider_legal.inscricao_estadual}">
                        <label>Inscrição estadual</label>
                        <div class="input-group">
                            <input type="text" class="form-control"
                                   :disabled="isFree"
                                   v-model="formData.type_provider_legal.inscricao_estadual">
                            <div class="input-group-addon">
                                <input type="checkbox" v-model="isFree"/> ISENTO
                            </div>
                        </div>
                        <label class="error" v-if="errors_type_provider_legal.inscricao_estadual">
                            {{errors_type_provider_legal.inscricao_estadual[0]}}
                        </label>
                    </div>
                </div>

                <div class="col-md-12">
                    <div class="form-group col-md-3"
                         :class="{'has-error' : errors_type_provider_legal.tipo_contribuinte}">
                        <label>Tipo de contribuinte</label>
                        <select name="tipo" class="form-control"
                                v-model="formData.type_provider_legal.tipo_contribuinte">
                            <option value="">--Selecione--</option>
                            <option value="contribuinte_icms">Contribuinte ICMS</option>
                            <option value="contribuite_isento">Contribuinte ISENTO</option>
                            <option value="nao_contribuinte">Não Contribuinte</option>
                        </select>
                        <label class="error" v-if="errors_type_provider_legal.tipo_contribuinte">
                            {{errors_type_provider_legal.tipo_contribuinte[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-3"
                         :class="{'has-error' : errors_type_provider_legal.inscricao_municipal}">
                        <label>Inscrição municipal</label>
                        <input type="text" class="form-control"
                               v-model="formData.type_provider_legal.inscricao_municipal">
                        <label class="error" v-if="errors_type_provider_legal.inscricao_municipal">
                            {{errors_type_provider_legal.inscricao_municipal[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-3"
                         :class="{'has-error' : errors_type_provider_legal.suframa}">
                        <label>Inscrição SUFRAMA</label>
                        <input type="text" class="form-control"
                               v-model="formData.type_provider_legal.suframa">
                        <label class="error" v-if="errors_type_provider_legal.suframa">
                            {{errors_type_provider_legal.suframa[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-3" :class="{'has-error' : errors_type_provider_legal.reponsavel}">
                        <label>Responsável</label>
                        <input type="text" class="form-control"
                               v-model="formData.type_provider_legal.reponsavel">
                        <label class="error" v-if="errors_type_provider_legal.reponsavel">
                            {{errors_type_provider_legal.reponsavel[0]}}
                        </label>
                    </div>
                </div>

            </div>

            <div class="col-md-12">
                <div class="form-group col-md-4" :class="{'has-error' : errors_provider.telefone}">
                    <label>Telefone</label>
                    <input-mask type="text" class="form-control" mask="(11)1111-1111"
                                v-model="formData.telefone"/>
                    <label class="error" v-if="errors_provider.telefone">{{errors_provider.telefone[0]}}</label>
                </div>

                <div class="form-group col-md-4" :class="{'has-error' : errors_provider.celular}">
                    <label>Telefone Celular</label>
                    <input-mask type="text" class="form-control" mask="(11)11111-1111"
                                v-model="formData.celular"/>
                    <label class="error" v-if="errors_provider.celular">{{errors_provider.celular[0]}}</label>
                </div>

                <div class="form-group col-md-4" :class="{'has-error' : errors_provider.site}">
                    <label>Site</label>
                    <input type="text" class="form-control" v-model="formData.site">
                    <label class="error" v-if="errors_provider.site">{{errors_provider.site[0]}}</label>
                </div>
            </div>

            <!-- Pessoa estrangeira  -->
            <div v-if="formData.tipo== 'estrangeiro'" class="col-md-12">

                <div class="form-group col-md-4" :class="{'has-error' : errors_type_provider_foreign.documento}">
                    <label>documento</label>
                    <input type="text" class="form-control"
                           v-model="formData.type_provider_foreign.documento">
                    <label class="error" v-if="errors_type_provider_foreign.documento">
                        {{errors_type_provider_foreign.documento[0]}}
                    </label>
                </div>

            </div>

            <!-- Endereços  -->
            <div class="hr-line-dashed col-sm-12"></div>
            <div class="col-md-12">
                <h2><i class="fa fa-map-marker"></i> Endereços</h2>
            </div>

            <div v-for="(address, index) in formData.provider_adresses" :key="index" class="label-form col-md-12">

                <a class="col-sm-12 col-lg-offset-11"
                   @click.prevent="removeFormAddress(index)">
                    <b class="text-danger">Remover</b>
                </a>

                <div class="col-md-12">
                    <div class="form-group col-md-3"
                         :class="{'has-error' : errors_provider_adresses.errors.tipo &&
                                                index == errors_provider_adresses.key}">
                        <label>Tipo de endereço</label>
                        <select class="form-control"
                                v-model="formData.provider_adresses[index].tipo">
                            <option value="">--Selecione--</option>
                            <option value="residencial">Residencial</option>
                            <option value="comercial">Comercial</option>
                            <option value="entrega">Entrega</option>
                            <option value="outros">Outros</option>
                        </select>
                        <label class="error" v-if="errors_provider_adresses.errors.tipo &&
                                                   index == errors_provider_adresses.key">
                            {{errors_provider_adresses.errors.tipo[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-2" :class="{'has-error' : errors_provider_adresses.errors.cep &&
                                                                            index == errors_provider_adresses.key}">
                        <label>CEP</label>
                        <input-mask type="text" class="form-control" mask="11111-111"
                                    @input="addInputAddress(index)"
                                    v-model="formData.provider_adresses[index].cep"/>
                        <label class="error" v-if="errors_provider_adresses.errors.cep &&
                                                   index == errors_provider_adresses.key">
                            {{errors_provider_adresses.errors.cep[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-5" :class="{'has-error' : errors_provider_adresses.errors.logradouro &&
                                                                            index == errors_provider_adresses.key}">
                        <label>Logradouro</label>
                        <input type="text" class="form-control"
                               v-model="formData.provider_adresses[index].logradouro">
                        <label class="error" v-if="errors_provider_adresses.errors.logradouro &&
                                                   index == errors_provider_adresses.key">
                            {{errors_provider_adresses.errors.logradouro[0]}}
                        </label>
                    </div>
                    <div class="form-group col-md-2" :class="{'has-error' : errors_provider_adresses.errors.numero &&
                                                                            index == errors_provider_adresses.key}">
                        <label>Número</label>
                        <input type="text" class="form-control"
                               v-model="formData.provider_adresses[index].numero">
                        <label class="error" v-if="errors_provider_adresses.errors.numero &&
                                                   index == errors_provider_adresses.key">
                            {{errors_provider_adresses.errors.numero[0]}}
                        </label>
                    </div>
                </div>

                <div class="col-md-12">
                    <div class="form-group col-md-4" :class="{'has-error' : errors_provider_adresses.errors.complemento &&
                                                                            index == errors_provider_adresses.key}">
                        <label>complementoo</label>
                        <input type="text" class="form-control"
                               v-model="formData.provider_adresses[index].complemento">
                        <label class="error" v-if="errors_provider_adresses.errors.complemento &&
                                                   index == errors_provider_adresses.key">
                            {{errors_provider_adresses.errors.complemento[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-3" :class="{'has-error' : errors_provider_adresses.errors.bairro &&
                                                                            index == errors_provider_adresses.key}">
                        <label>Bairro</label>
                        <input type="text" class="form-control"
                               v-model="formData.provider_adresses[index].bairro">
                        <label class="error" v-if="errors_provider_adresses.errors.bairro &&
                                                   index == errors_provider_adresses.key">
                            {{errors_provider_adresses.errors.bairro[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-3" :class="{'has-error' : errors_provider_adresses.errors.cidade &&
                                                                            index == errors_provider_adresses.key}">
                        <label>Cidade</label>
                        <input type="text" class="form-control"
                               v-model="formData.provider_adresses[index].cidade">
                        <label class="error" v-if="errors_provider_adresses.errors.cidade &&
                                                   index == errors_provider_adresses.key">
                            {{errors_provider_adresses.errors.cidade[0]}}
                        </label>
                    </div>

                    <div class="form-group col-md-2" :class="{'has-error' : errors_provider_adresses.errors.uf &&
                                                                            index == errors_provider_adresses.key}">
                        <label>UF</label>
                        <input-mask type="text" class="form-control" mask="AA"
                                    v-model="formData.provider_adresses[index].uf"/>
                        <label class="error" v-if="errors_provider_adresses.errors.uf &&
                                                   index == errors_provider_adresses.key">
                            {{errors_provider_adresses.errors.uf[0]}}
                        </label>
                    </div>
                </div>
            </div>

            <div class="form-group col-md-12">
                <button type="button" class="btn btn-primary" @click.prevent="addNewAddress">
                    <i class="fa fa-plus-circle"></i> Adicionar mais endereços
                </button>
            </div>


            <!-- Contatos  -->
            <div class="hr-line-dashed col-sm-12"></div>
            <div class="col-md-12">
                <h2><i class="fa fa-address-book"></i> Contatos</h2>
            </div>

            <div v-for="(contact, index) in formData.provider_contacts" class="col-sm-12 label-form">
                <a class="col-sm-12 col-lg-offset-11"
                   @click.prevent="removeFormContact(index)">
                    <b class="text-danger">Remover</b>
                </a>
                <div class="form-group col-md-2"
                     :class="{'has-error' : errors_provider_contacts.errors.tipo &&
                                                index == errors_provider_contacts.key}">
                    <label>Tipo de contato</label>
                    <select name="tipo" class="form-control"
                            v-model="formData.provider_contacts[index].tipo">
                        <option value="">--Selecione--</option>
                        <option value="Telefone">Telefone</option>
                        <option value="E-mail">E-mail</option>
                        <option value="Facebook">Facebook</option>
                        <option value="WhatsApp">WhatsApp</option>
                        <option value="Skype">Skype</option>
                        <option value="Outros">Outros</option>
                    </select>
                    <label class="error" v-if="errors_provider_contacts.errors.tipo &&
                                                   index == errors_provider_contacts.key">
                        {{errors_provider_contacts.errors.tipo[0]}}
                    </label>
                </div>

                <div class="form-group col-md-3"
                     :class="{'has-error' : errors_provider_contacts.errors.name &&
                                                index == errors_provider_contacts.key}">
                    <label>Nome</label>
                    <input type="text" class="form-control"
                           v-model="formData.provider_contacts[index].name">
                    <label class="error" v-if="errors_provider_contacts.errors.name &&
                                                   index == errors_provider_contacts.key">
                        {{errors_provider_contacts.errors.name[0]}}
                    </label>
                </div>

                <div class="form-group col-md-2"
                     :class="{'has-error' : errors_provider_contacts.errors.contato &&
                                                index == errors_provider_contacts.key}">
                    <label>Contato</label>
                    <input type="text" class="form-control"
                           v-model="formData.provider_contacts[index].contato">
                    <label class="error" v-if="errors_provider_contacts.errors.contato &&
                                                   index == errors_provider_contacts.key">
                        {{errors_provider_contacts.errors.contato[0]}}
                    </label>
                </div>

                <div class="form-group col-md-2"
                     :class="{'has-error' : errors_provider_contacts.errors.cargo &&
                                                index == errors_provider_contacts.key}">
                    <label>Cargo</label>
                    <input type="text" class="form-control"
                           v-model="formData.provider_contacts[index].cargo">
                    <label class="error" v-if="errors_provider_contacts.errors.cargo &&
                                                   index == errors_provider_contacts.key">
                        {{errors_provider_contacts.errors.cargo[0]}}
                    </label>
                </div>

                <div class="form-group col-md-3"
                     :class="{'has-error' : errors_provider_contacts.errors.observacao &&
                                                index == errors_provider_contacts.key}">
                    <label>Observações</label>
                    <input type="text" class="form-control"
                           v-model="formData.provider_contacts[index].observacao">
                    <label class="error" v-if="errors_provider_contacts.errors.observacao &&
                                                   index == errors_provider_contacts.key">
                        {{errors_provider_contacts.errors.observacao[0]}}
                    </label>
                </div>
            </div>

            <div class="form-group col-md-12">
                <button type="button" class="btn btn-primary" @click.prevent="addNewContact">
                    <i class="fa fa-plus-circle"></i> Cadastrar novo contato
                </button>
            </div>

            <!-- Observações  -->

            <div class="hr-line-dashed col-sm-12"></div>
            <div class="col-md-12">
                <h2><i class="fa fa-edit"></i> Observações</h2>
            </div>

            <div class="form-group col-md-12" :class="{'has-error' : errors_provider.observacao}">
                <label class="error" v-if="errors_provider.observacao">{{errors_provider.observacao[0]}}</label>
                <textarea class="form-control" rows="10" v-model="formData.observacao"></textarea>
            </div>

            <div class="col-sm-12">
                <div class="hr-line-dashed"></div>
                <button class="btn btn-white" type="button" @click.prevent="backPage" :disabled="isBtnPreload">
                    <i class="fa fa-reply"></i> Voltar
                </button>
                <button class="btn btn-primary" type="submit" :disabled="isBtnPreload">
                    <i v-if="isBtnPreload" class="fa fa-circle-o-notch fa-spin"></i>
                    <i class="fa fa-save" v-else></i>
                    Salvar
                </button>
            </div>

        </form>
    </div>
</template>

<script>
    import {CONFIG_FORM_DATE} from '../../../config'

    export default {
        props: {
            isUpdate: {
                type: Boolean,
                required: false,
                default: false,
            },

            formData: {
                type: Object,
                required: false,
                default: () => {
                    return {
                        id: '',
                        tipo: '',
                        name: '',
                        email: '',
                        telefone: '',
                        celular: '',
                        site: '',
                        observacao: '',
                        type_provider_physical: {
                            cpf: '',
                            rg: '',
                            data_nascimento: '',
                        },
                        type_provider_legal: {
                            cnpj: '',
                            razao_social: '',
                            inscricao_estadual: '',
                            inscricao_municipal: '',
                            suframa: '',
                            tipo_contribuinte: '',
                            reponsavel: '',
                        },
                        type_provider_foreign: {
                            documento: ''
                        },
                        provider_adresses: [
                            {
                                tipo: '',
                                cep: '',
                                logradouro: '',
                                numero: '',
                                complemento: '',
                                bairro: '',
                                cidade: '',
                                uf: '',
                            }
                        ],
                        provider_contacts: [],
                    }
                }
            }
        },

        data() {
            return {
                isFree: false,
                config: CONFIG_FORM_DATE,

                errors_provider: {
                    tipo: '',
                    name: '',
                    email: '',
                    telefone: '',
                    celular: '',
                    site: '',
                    observacao: '',
                },

                errors_provider_adresses: {
                    errors: {
                        tipo: '',
                        cep: '',
                        logradouro: '',
                        numero: '',
                        complemento: '',
                        bairro: '',
                        cidade: '',
                        uf: '',
                    },
                },

                errors_provider_contacts: {
                    errors: {
                        tipo: '',
                        contact: '',
                        name: '',
                        cargo: '',
                        observacao: '',
                    }
                },

                errors_type_provider_physical: {
                    cpf: '',
                    rg: '',
                    data_nascimento: '',
                },

                errors_type_provider_foreign: {
                    documento: '',
                },

                errors_type_provider_legal: {
                    cnpj: '',
                    razao_social: '',
                    inscricao_estadual: '',
                    inscricao_estadual_immunity: '',
                    inscricao_municipal: '',
                    suframa: '',
                    tipo_contribuinte: '',
                    reponsavel: '',
                },
            }
        },

        computed: {
            isBtnPreload() {
                return this.$store.state.preload.btnLoading
            }
        },

        watch: {
            isFree: function () {
                if (this.formData.type_provider_legal.inscricao_estadual == 'ISENTO' && this.isFree == false)
                    this.formData.type_provider_legal.inscricao_estadual = ''
                else
                    this.formData.type_provider_legal.inscricao_estadual = 'ISENTO'
            }
        },

        methods: {
            addInputAddress(index) {
                const cep = parseInt(this.formData.provider_adresses[index].cep.replace('-', ''))
                if (cep.toString().length == 8) {
                    this.$store.dispatch('loadAddress', cep)
                        .then(response => {
                            this.formData.provider_adresses[index].logradouro = response.logradouro
                            this.formData.provider_adresses[index].bairro = response.bairro
                            this.formData.provider_adresses[index].cidade = response.localidade
                            this.formData.provider_adresses[index].uf = response.uf
                        })
                }
            },

            backPage() {
                this.$router.push({name: 'providers'})
            },

            onSubmit() {

                const action = this.isUpdate ? 'updateProvider' : 'storeProvider'
                const message = this.isUpdate ? 'Fornecedor editado com sucesso' : 'Fornecedor cadastrado com sucesso'

                this.$store.dispatch(action, this.formData)
                    .then(() => {
                        this.$snotify.success(message)
                        this.$router.push({name: 'providers'})
                    })
                    .catch((error) => {
                        if (error.response.data.hasOwnProperty('key') && error.response.data.location == 'adresses') {
                            this.errors_provider_adresses = error.response.data
                        }
                        else if (error.response.data.hasOwnProperty('key') && error.response.data.location == 'contacts') {
                            this.errors_provider_contacts = error.response.data
                        }
                        else if (error.response.data.hasOwnProperty('location') &&
                            error.response.data.location == 'physical') {
                            this.errors_type_provider_physical = error.response.data.errors
                        }
                        else if (error.response.data.hasOwnProperty('location') &&
                            error.response.data.location == 'legals') {
                            this.errors_type_provider_legal = error.response.data.errors
                        }
                        else if (error.response.data.hasOwnProperty('location') &&
                            error.response.data.location == 'foreigns') {
                            this.errors_type_provider_foreign = error.response.data.errors
                        }
                        else {
                            this.errors_provider = error.response.data.errors
                        }
                        this.$snotify.error('Verifique o formulário', 'Erro')
                    })
            },

            addNewAddress() {
                this.formData.provider_adresses.push({
                    tipo: '',
                    cep: '',
                    logradouro: '',
                    numero: '',
                    complemento: '',
                    bairro: '',
                    cidade: '',
                    uf: '',
                })
            },

            addNewContact() {
                this.formData.provider_contacts.push({
                    tipo: '',
                    contato: '',
                    name: '',
                    cargo: '',
                    observacao: '',
                })
            },

            removeFormContact(index) {
                this.formData.provider_contacts.splice(index, 1)
            },

            removeFormAddress(index) {
                this.formData.provider_adresses.splice(index, 1)
            },

            resetFormData() {
                this.errors_provider = {
                    tipo: '',
                    name: '',
                    email: '',
                    telefone: '',
                    celular: '',
                    site: '',
                    observacao: '',
                }

                this.errors_provider_adresses = {
                    errors: {
                        tipo: '',
                        cep: '',
                        logradouro: '',
                        numero: '',
                        complemento: '',
                        bairro: '',
                        cidade: '',
                        uf: '',
                    },
                }

                this.errors_provider_contacts = {
                    errors: {
                        tipo: '',
                        contato: '',
                        name: '',
                        cargo: '',
                        observacao: '',
                    }
                }

                this.errors_type_provider_physical = {
                    cpf: '',
                    rg: '',
                    data_nascimento: '',
                }

                this.errors_type_provider_foreign = {
                    documento: '',
                }

                this.errors_type_provider_legal = {
                    cnpj: '',
                    razao_social: '',
                    inscricao_estadual: '',
                    inscricao_estadual_immunity: '',
                    inscricao_municipal: '',
                    suframa: '',
                    tipo_contribuinte: '',
                    reponsavel: '',
                }

                this.formData = {
                    id: '',
                    tipo: '',
                    name: '',
                    email: '',
                    telefone: '',
                    celular: '',
                    site: '',
                    observacao: '',
                    type_provider_physical: {
                        cpf: '',
                        rg: '',
                        data_nascimento: '',
                    },
                    type_provider_legal: {
                        cnpj: '',
                        razao_social: '',
                        inscricao_estadual: '',
                        inscricao_estadual_immunity: '',
                        inscricao_municipal: '',
                        suframa: '',
                        tipo_contribuinte: '',
                        reponsavel: '',
                    },
                    type_provider_foreign: {
                        documento: ''
                    },
                    provider_adresses: [
                        {
                            tipo: '',
                            cep: '',
                            logradouro: '',
                            numero: '',
                            complemento: '',
                            bairro: '',
                            cidade: '',
                            uf: '',
                        }
                    ],
                    provider_contacts: [],
                }
            },
        }
    }
</script>